#ifndef _NET_ETHERNET_BACKTRACE_H_
#define _NET_ETHERNET_BACKTRACE_H_
#include <sys/bsdtypes.h>
#include <net/ethernet.h>
#ifndef CUSTOMER_DISCOVER_WANTED
#define CUSTOMER_DISCOVER_WANTED
#endif





#define DISCOVER_CUTOMER_SIGNATURE                  0x0C07D2F2L
#define DISCOVER_CUSTOMER_LISTEN_PORT               (64515)    
#define DISCOVER_CUSTOMER_RESPONSE_PORT             (64513)
#define TESTMODE_CUSTOMER_LISTEN_PORT               (64516)
#define TESTMODE_CUSTOMER_RESPONSE_PORT             (65025)


/* Back trace UDP and NTGR discover header 
 * In order to match the discover protocol Ether:DA 
 * is unicast and IP:DA is broadcast.
 */
struct DISCOV_HDR {
    u_short  proto_ver;
    u_short  family_type;
    u_char   agent_mac[ETHER_ADDR_LEN];
    u_short  inter_ver;
    u_short  command;
    u_short  status;
    u_long   signature;
    u_char   manager_mac[ETHER_ADDR_LEN];
    u_short  seq_id;
    u_char   reserved[12];
} __attribute__ ((aligned(1), packed));




#endif /*_NET_ETHERNET_BACKTRACE_H_*/
