#ifndef __MIB_DEFINES_H__
#define __MIB_DEFINES_H__

/* Generic directives */
#define OID_NOT_WRITABLE            0
#define IP_ADDRESS_LEN              4
#define MAC_ADDRESS_LEN             6
#define INTERFACE_BYTE_COUNT        8

/* Enable or disable values */
#define MIB_STATUS_ENABLED          1
#define MIB_STATUS_DISABLED         2

/* Return codes */
#define MIB_STATUS_SUCCESS          0
#define MIB_STATUS_ERROR            1

/* Row Status Values */
#define MIB_ROWSTATUS_ACTIVE        1
#define MIB_ROWSTATUS_NOTREADY      3
#define MIB_ROWSTATUS_CREATEANDGO   4
#define MIB_ROWSTATUS_CREATEANDWAIT 5
#define MIB_ROWSTATUS_DESTROY       6

/* gs748t MIBs description*/
#define SS_NGR_GS748T_MIB           "gs748tMib"
#define SS_HOST_GROUP_MIB           "ssHostGroup"
#define SS_SPAN_GROUP_MIB           "ssSpanGroup"
#define SS_CONF_GROUP_MIB           "ssConfigGroup"
#define SS_PVLAN_GROUP_MIB          "ssPVlanGroup"
#define SS_TVLAN_GROUP_MIB          "ssTVlanGroup"
#define SS_TRUNK_GROUP_MIB          "ssTrunkGroup"
#define SS_QOS_GROUP_MIB            "ssQosGroup"
#define SS_TRUSTMAC_GROUP_MIB       "ssTrustMacGroup"
#define SS_IGMPSNOOP_GROUP_MIB      "ssIgmpSnoopGroup"
#define SS_STATICMCAST_GROUP_MIB    "ssStaticMulticastGroup"
#define SS_MGMTVLAN_GROUP_MIB       "ssMgmtVlanGroup"

/* MIBII MIBs description */
#define MIBII_AT_MIB                "atMIB"
#define MIBII_DOT1DBASE_MIB         "dot1dBase"
#define MIBII_DOT1DEXTBASE_MIB      "dot1dExtBase"
#define MIBII_DOT1DGARP_MIB         "dot1dGarp"
#define MIBII_DOT1DGMRP_MIB         "dot1dGmrp"
#define MIBII_DOT1DPRIORITY_MIB     "dot1dPriority"
#define MIBII_DOT1DSTATIC_MIB       "dot1dStatic"
#define MIBII_DOT1DSTP_MIB          "dot1dStp"
#define MIBII_DOT1DTP_MIB           "dot1dTp"
#define MIBII_DOT1QBASE_MIB         "dot1qBase"
#define MIBII_DOT1QSTATIC_MIB       "dot1qStatic"
#define MIBII_DOT1QTP_MIB           "dot1qTp"
#define MIBII_DOT1QVLAN_MIB         "dot1qVlan"

/* ssHost group directives */
#define HOST_ATTRIB_RONLY           1
#define HOST_ATTRIB_RWRITE          2

/* ssConfGroup directives */
#define MIB_VLAN_MODE_PORTBASED     1
#define MIB_VLAN_MODE_TAGGED        2

/* ssQos directives */
#define SS_QOS_MODE_PORTBASED       1
#define SS_QOS_MODE_1PBASED         2
#define SS_QOS_MODE_TOSBASED        3
#define SS_QOS_MODE_DSCPBASED       4
#define SS_TOS_NUM_QUEUES           8
#define SS_QOS_PRIO_LOWEST          1
#define SS_QOS_PRIO_HIGHEST         4
#define SS_QOS_MIN_PRIORITY         1
#define SS_QOS_MAX_PRIORITY         8

/* ssTvlan group directives */
#define SS_TVLAN_PORT_PRIO_MIN      0
#define SS_TVLAN_PORT_PRIO_MAX      7

/* Spanning tree directives */
#define C_BRIDGE_ROOT_LEN           8
#define C_STP_PRIORITY_MASK         0x0FFF
#define C_BRIDGE_MIN_MAXAGE         600
#define C_BRIDGE_MAX_MAXAGE         4000
#define C_BRIDGE_MIN_HELLOTIME      100
#define C_BRIDGE_MAX_HELLOTIME      1000
#define C_BRIDGE_MIN_FWDELAY        400
#define C_BRIDGE_MAX_FWDELAY        3000
#define C_BRIDGE_STPVER_STPCOMPAT   0
#define C_BRIDGE_STPVER_RSTP        2
#define C_STP_TXHOLDCNT_MIN         1
#define C_STP_TXHOLDCNT_MAX         10
#define C_STP_PCOST_1998            1
#define C_STP_PCOST_2001            2
#define C_STP_PORTPRIO_MAX          255
#define C_STP_PATHCOST_MAX          65535
#define C_STP_PRIORITY_MAX          65535
#define C_STP_ADMINP2P_TRUE         0
#define C_STP_ADMINP2P_AUTO         2

/* TP directives */
#define C_L2_AGINGTIME_MIN          10
#define C_L2_AGINGTIME_MAX          1000000

/* dot1d/dot1qStatic directives */
#define C_STATIC_STATUS_OTHER       1 
#define C_STATIC_STATUS_INVALID     2
#define C_STATIC_STATUS_PERMANENT   3
#define C_STATIC_STATUS_DELONRESET  4
#define C_STATIC_STATUS_DELONTMOUT  5

/* VLAN directives */
#define C_PORT_FRAMETYPE_ALL        1
#define C_PORT_FRAMETYPE_TAGGED     2
#endif
