//==========================================================================
//
//      ./agent/current/include/vacm_vars.h
//
//
//==========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//####UCDSNMPCOPYRIGHTBEGIN####
//
// -------------------------------------------
//
// Portions of this software may have been derived from the UCD-SNMP
// project,  <http://ucd-snmp.ucdavis.edu/>  from the University of
// California at Davis, which was originally based on the Carnegie Mellon
// University SNMP implementation.  Portions of this software are therefore
// covered by the appropriate copyright disclaimers included herein.
//
// The release used was version 4.1.2 of May 2000.  "ucd-snmp-4.1.2"
// -------------------------------------------
//
//####UCDSNMPCOPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Manu Sharma
// Contributors: 
// Date:         2002-11-01
// Purpose:      Port of UCD-SNMP distribution to eCos.
// Description:  
//              
//
//####DESCRIPTIONEND####
//
//==========================================================================
/********************************************************************
       Copyright 1989, 1991, 1992 by Carnegie Mellon University

			  Derivative Work -
Copyright 1996, 1998, 1999, 2000 The Regents of the University of California

			 All Rights Reserved

Permission to use, copy, modify and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appears in all copies and
that both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU and The Regents of
the University of California not be used in advertising or publicity
pertaining to distribution of the software without specific written
permission.

CMU AND THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL
WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL CMU OR
THE REGENTS OF THE UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
FROM THE LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*********************************************************************/
/*
 * SNMPv3 View-based Access Control Model
 */

#ifndef _MIBGROUP_VACM_H
#define _MIBGROUP_VACM_H


#define WSS_SNMP_SEC_MODEL_ANY		0
#define WSS_SNMP_SEC_MODEL_SNMPv1	1
#define WSS_SNMP_SEC_MODEL_SNMPv2c	2
#define WSS_SNMP_SEC_MODEL_SNMPv3	3

#define WSS_SNMP_SEC_LEVEL_NOAUTH 1
#define WSS_SNMP_SEC_LEVEL_AUTHNOPRIV 2
#define WSS_SNMP_SEC_LEVEL_AUTHPRIV 3

#define WSS_SNMP_AUTH_TYPE_NONE 0
#define WSS_SNMP_AUTH_TYPE_MD5  1

#define WSS_SNMP_TRAP_FLAG_AUTHFAIL (1 << 0)
#define WSS_SNMP_TRAP_FLAG_BOOTUP (1 << 1)
#define WSS_SNMP_TRAP_FLAG_LINK (1 << 2)

int wss_snmp_set_group_cnt(int group_cnt);
int wss_snmp_parse_simple(char *token, char *str);
int wss_snmp_create_access_entry(char *access_str);

int wss_snmp_del_access_entry(const char *groupName, 
                                       const char *contextPrefix,
                                       int securityModel,
                                       int securityLevel);

int wss_snmp_create_view_entry(char *view_str);

int wss_snmp_create_group_entry(char *group_str);
int wss_snmp_del_group_entry(int securityModel, char *securityName);
int wss_snmp_create_user_entry(char *user_str);
int wss_snmp_del_user_entry(char *user_name, char *engineID, int engineIDLen);

int wss_snmp_create_security_entry(char *str);
int wss_snmp_del_security_entry(void);

int wss_snmp_auth_notify_enable_set(int param1, int param2);
int wss_snmp_auth_notify_enable_get(int *param1, int *param2);

int wss_snmp_create_trap(int, char *ip, char *com);
int wss_snmp_del_trap(void);
void send_link_trap( int port, int link, int flag);
void send_start_trap(void);
void send_auth_trap(char *buf);

#ifdef CYGPKG_SNMPAGENT_V3_SUPPORT
#ifdef CYGPKG_SNMPLIB_FILESYSTEM_SUPPORT

config_require(util_funcs)
config_add_mib(SNMP-VIEW-BASED-ACM-MIB) 
config_add_mib(SNMP-COMMUNITY-MIB)

void init_vacm_vars (void);
void vacm_free_security (void);
void vacm_free_group (void);
void vacm_free_access (void);
void vacm_free_view (void);
void vacm_parse_security (const char *, char *);
void vacm_parse_group (const char *, char *);
void vacm_parse_access (const char *, char *);
void vacm_parse_view (const char *, char *);
void vacm_parse_simple (const char *, char *);

SNMPCallback vacm_in_view_callback;

int vacm_in_view (struct snmp_pdu *, oid *, size_t);

extern FindVarMethod var_vacm_sec2group;
extern FindVarMethod var_vacm_access;
extern FindVarMethod var_vacm_view;

#define OID_SNMPVACMMIB		SNMP_OID_SNMPMODULES, 16
#define OID_VACMMIBOBJECTS	OID_SNMPVACMMIB, 1

#define OID_VACMCONTEXTTABLE	OID_VACMMIBOBJECTS, 1
#define OID_VACMCONTEXTENTRY	OID_VACMCONTEXTTABLE, 1

#define OID_VACMGROUPTABLE	OID_VACMMIBOBJECTS, 2
#define OID_VACMGROUPENTRY	OID_VACMGROUPTABLE, 1

#define OID_VACMACCESSTABLE	OID_VACMMIBOBJECTS, 4
#define OID_VACMACCESSENTRY	OID_VACMACCESSTABLE, 1

#define OID_VACMMIBVIEWS	OID_VACMMIBOBJECTS, 5
#define OID_VACMVIEWTABLE	OID_VACMMIBVIEWS, 2
#define OID_VACMVIEWENTRY	OID_VACMVIEWTABLE, 1

#endif    /* CYGPKG_SNMPLIB_FILESYSTEM_SUPPORT */
#endif    /* CYGPKG_SNMPAGENT_V3_SUPPORT */

#endif /* _MIBGROUP_VACM_H */
